#define		GETCIRCUITSIGNATURE		"getCircuitSignature"
#define		GETCREATORSIGNATURE		"getCreatorSignature"
#define		GETENTRYCOUNT			"getEntryCount"
#define		GETENTRYSPECS			"getEntrySpecs"

	// Signature Code of this Round.
#define		CIRCUITSIGNATURE		2

	// Length of structures.
#define		MAXENTRY	32 
#define		MAXNAMELEN	64

	// Required Features Flags
#define		RF_FPU		1
#define		RF_MMX		2
#define		RF_3DNOW	4
#define		RF_KNI		8
#define		RF_CMOV		16

#define		RF_SOA		256

	// size of data structure
#define		SZINVECTOR	36
#define		SZOUTVECTOR	18

	// for getEntrySpec function.
struct TPROCSPEC
{
	char	name[MAXNAMELEN];
	int		reqFeatures;
};

#define SETSPEC( spec, description, reqspecs ) \
	strcpy( spec.name, description );\
	spec.reqFeatures = (reqspecs);\


						// return the CIRCUITSIGNATURE	
extern "C" int		 WINAPI  getCircuitSignature();

						// usually, return your name
extern "C" char*	 WINAPI  getCreatorSignature( char * sig );

						// return how may entry for race, in your DLL.
extern "C" int		 WINAPI  getEntryCount();

						// return the description and required hardware for each entry
extern "C" void		 WINAPI  getEntrySpecs( struct TPROCSPEC * procSpec ); 

						// run selected algorithm by i.
extern "C"  void		WINAPI runEntry( int entry, float  coeff[SZOUTVECTOR][SZINVECTOR], float  in_vector[SZINVECTOR], float out_vector[SZOUTVECTOR], int count );

// end of file.