
%include "nasm.h"

[segment_code]

;***************************************************************

proc	entry_x87

		%$coeff			arg		4
		%$in_vector		arg		4
		%$out_vector	arg		4
		%$count			arg		4

		pushd	ebp, edi, esi, ebx

		mov		r0, [sp(%$in_vector)]
		add		r0, fsizen(18)
		add		dword [sp(%$coeff)], fsizen(18)
		mov		r2, [sp(%$count)]
		jmp		.lp_count

		align 16
.lp_count:
		mov		r3, [sp(%$coeff)]
		mov		r1, [sp(%$out_vector)]
		mov		r4, 18
		jmp		.lp_18

		align 16
.lp_18:
		fld		dword [r3+ fsizen(0) -fsizen(18)]
		fmul	dword [r0+ fsizen(0) -fsizen(18)]
		fld		dword [r3+ fsizen(1) -fsizen(18)]
		fmul	dword [r0+ fsizen(1) -fsizen(18)]
		fld		dword [r3+ fsizen(2) -fsizen(18)]
		fmul	dword [r0+ fsizen(2) -fsizen(18)]
		fld		dword [r3+ fsizen(3) -fsizen(18)]
		fmul	dword [r0+ fsizen(3) -fsizen(18)]
		fld		dword [r3+ fsizen(4) -fsizen(18)]
		fmul	dword [r0+ fsizen(4) -fsizen(18)]
		fld		dword [r3+ fsizen(5) -fsizen(18)]
		fmul	dword [r0+ fsizen(5) -fsizen(18)]
		fld		dword [r3+ fsizen(6) -fsizen(18)]
		fmul	dword [r0+ fsizen(6) -fsizen(18)]
		fld		dword [r3+ fsizen(7) -fsizen(18)]
		fmul	dword [r0+ fsizen(7) -fsizen(18)]
		faddp	st7, st0
		faddp	st5, st0
		faddp	st3, st0
		faddp	st1, st0
		faddp	st3, st0
		faddp	st1, st0
		faddp	st1, st0

		fld		dword [r3+ fsizen(8) -fsizen(18)]
		fmul	dword [r0+ fsizen(8) -fsizen(18)]
		fld		dword [r3+ fsizen(9) -fsizen(18)]
		fmul	dword [r0+ fsizen(9) -fsizen(18)]
		fld		dword [r3+ fsizen(10) -fsizen(18)]
		fmul	dword [r0+ fsizen(10) -fsizen(18)]
		fld		dword [r3+ fsizen(11) -fsizen(18)]
		fmul	dword [r0+ fsizen(11) -fsizen(18)]
		fld		dword [r3+ fsizen(12) -fsizen(18)]
		fmul	dword [r0+ fsizen(12) -fsizen(18)]
		fld		dword [r3+ fsizen(13) -fsizen(18)]
		fmul	dword [r0+ fsizen(13) -fsizen(18)]
		fld		dword [r3+ fsizen(14) -fsizen(18)]
		fmul	dword [r0+ fsizen(14) -fsizen(18)]
		faddp	st7, st0
		faddp	st5, st0
		faddp	st3, st0
		faddp	st1, st0
		faddp	st3, st0
		faddp	st1, st0
		faddp	st1, st0

		fld		dword [r3+ fsizen(15) -fsizen(18)]
		fmul	dword [r0+ fsizen(15) -fsizen(18)]
		fld		dword [r3+ fsizen(16) -fsizen(18)]
		fmul	dword [r0+ fsizen(16) -fsizen(18)]
		fld		dword [r3+ fsizen(17) -fsizen(18)]
		fmul	dword [r0+ fsizen(17) -fsizen(18)]
		fld		dword [r3+ fsizen(0)]
		fmul	dword [r0+ fsizen(0)]
		fld		dword [r3+ fsizen(1)]
		fmul	dword [r0+ fsizen(1)]
		fld		dword [r3+ fsizen(2)]
		fmul	dword [r0+ fsizen(2)]
		fld		dword [r3+ fsizen(3)]
		fmul	dword [r0+ fsizen(3)]
		faddp	st7, st0
		faddp	st5, st0
		faddp	st3, st0
		faddp	st1, st0
		faddp	st3, st0
		faddp	st1, st0
		faddp	st1, st0

		fld		dword [r3+ fsizen(4)]
		fmul	dword [r0+ fsizen(4)]
		fld		dword [r3+ fsizen(5)]
		fmul	dword [r0+ fsizen(5)]
		fld		dword [r3+ fsizen(6)]
		fmul	dword [r0+ fsizen(6)]
		fld		dword [r3+ fsizen(7)]
		fmul	dword [r0+ fsizen(7)]
		fld		dword [r3+ fsizen(8)]
		fmul	dword [r0+ fsizen(8)]
		fld		dword [r3+ fsizen(9)]
		fmul	dword [r0+ fsizen(9)]
		fld		dword [r3+ fsizen(10)]
		fmul	dword [r0+ fsizen(10)]
		faddp	st7, st0
		faddp	st5, st0
		faddp	st3, st0
		faddp	st1, st0
		faddp	st3, st0
		faddp	st1, st0
		faddp	st1, st0

		fld		dword [r3+ fsizen(11)]
		fmul	dword [r0+ fsizen(11)]
		fld		dword [r3+ fsizen(12)]
		fmul	dword [r0+ fsizen(12)]
		fld		dword [r3+ fsizen(13)]
		fmul	dword [r0+ fsizen(13)]
		fld		dword [r3+ fsizen(14)]
		fmul	dword [r0+ fsizen(14)]
		fld		dword [r3+ fsizen(15)]
		fmul	dword [r0+ fsizen(15)]
		fld		dword [r3+ fsizen(16)]
		fmul	dword [r0+ fsizen(16)]
		fld		dword [r3+ fsizen(17)]
		fmul	dword [r0+ fsizen(17)]
		faddp	st7, st0
		faddp	st5, st0
		faddp	st3, st0
		faddp	st1, st0
		faddp	st3, st0
		add		r1, fsize
		faddp	st1, st0
		add		r3, fsizen(36)
		faddp	st1, st0

		dec		r4
		fstp	dword [r1-fsize]
		jnz near .lp_18

		dec		r2
		jnz near .lp_count

		popd	ebp, edi, esi, ebx
endproc

;***************************************************************

proc	entry_x87_fxch

		%$coeff			arg		4
		%$in_vector		arg		4
		%$out_vector	arg		4
		%$count			arg		4

		pushd	ebp, edi, esi, ebx

		mov		r0, [sp(%$in_vector)]
		add		r0, fsizen(18)
		add		dword [sp(%$coeff)], fsizen(18)
		mov		r2, [sp(%$count)]
		jmp		.lp_count

		align 16
.lp_count:
		mov		r3, [sp(%$coeff)]
		mov		r1, [sp(%$out_vector)]
		mov		r4, 18
		jmp		.lp_18

		align 16
.lp_18:
		fld		dword [r3+ fsizen(0) -fsizen(18)]
		fmul	dword [r0+ fsizen(0) -fsizen(18)]
		fld		dword [r3+ fsizen(1) -fsizen(18)]
		fmul	dword [r0+ fsizen(1) -fsizen(18)]
		fld		dword [r3+ fsizen(2) -fsizen(18)]
		fmul	dword [r0+ fsizen(2) -fsizen(18)]
		fld		dword [r3+ fsizen(3) -fsizen(18)]
		fmul	dword [r0+ fsizen(3) -fsizen(18)]
		fld		dword [r3+ fsizen(4) -fsizen(18)]
		fmul	dword [r0+ fsizen(4) -fsizen(18)]
		fld		dword [r3+ fsizen(5) -fsizen(18)]
		fmul	dword [r0+ fsizen(5) -fsizen(18)]
		fxch	st4
		faddp	st5, st0
		fxch	st1
		faddp	st2, st0
		faddp	st2, st0

		fld		dword [r3+ fsizen(6) -fsizen(18)]
		fmul	dword [r0+ fsizen(6) -fsizen(18)]
		fld		dword [r3+ fsizen(7) -fsizen(18)]
		fmul	dword [r0+ fsizen(7) -fsizen(18)]
		fld		dword [r3+ fsizen(8) -fsizen(18)]
		fmul	dword [r0+ fsizen(8) -fsizen(18)]
		fxch	st4
		faddp	st5, st0
		fxch	st1
		faddp	st2, st0
		faddp	st2, st0

		fld		dword [r3+ fsizen(9) -fsizen(18)]
		fmul	dword [r0+ fsizen(9) -fsizen(18)]
		fld		dword [r3+ fsizen(10) -fsizen(18)]
		fmul	dword [r0+ fsizen(10) -fsizen(18)]
		fld		dword [r3+ fsizen(11) -fsizen(18)]
		fmul	dword [r0+ fsizen(11) -fsizen(18)]
		fxch	st4
		faddp	st5, st0
		fxch	st1
		faddp	st2, st0
		faddp	st2, st0

		fld		dword [r3+ fsizen(12) -fsizen(18)]
		fmul	dword [r0+ fsizen(12) -fsizen(18)]
		fld		dword [r3+ fsizen(13) -fsizen(18)]
		fmul	dword [r0+ fsizen(13) -fsizen(18)]
		fld		dword [r3+ fsizen(14) -fsizen(18)]
		fmul	dword [r0+ fsizen(14) -fsizen(18)]
		fxch	st4
		faddp	st5, st0
		fxch	st1
		faddp	st2, st0
		faddp	st2, st0

		fld		dword [r3+ fsizen(15) -fsizen(18)]
		fmul	dword [r0+ fsizen(15) -fsizen(18)]
		fld		dword [r3+ fsizen(16) -fsizen(18)]
		fmul	dword [r0+ fsizen(16) -fsizen(18)]
		fld		dword [r3+ fsizen(17) -fsizen(18)]
		fmul	dword [r0+ fsizen(17) -fsizen(18)]
		fxch	st4
		faddp	st5, st0
		fxch	st1
		faddp	st2, st0
		faddp	st2, st0

		fld		dword [r3+ fsizen(0)]
		fmul	dword [r0+ fsizen(0)]
		fld		dword [r3+ fsizen(1)]
		fmul	dword [r0+ fsizen(1)]
		fld		dword [r3+ fsizen(2)]
		fmul	dword [r0+ fsizen(2)]
		fxch	st4
		faddp	st5, st0
		fxch	st1
		faddp	st2, st0
		faddp	st2, st0

		fld		dword [r3+ fsizen(3)]
		fmul	dword [r0+ fsizen(3)]
		fld		dword [r3+ fsizen(4)]
		fmul	dword [r0+ fsizen(4)]
		fld		dword [r3+ fsizen(5)]
		fmul	dword [r0+ fsizen(5)]
		fxch	st4
		faddp	st5, st0
		fxch	st1
		faddp	st2, st0
		faddp	st2, st0

		fld		dword [r3+ fsizen(6)]
		fmul	dword [r0+ fsizen(6)]
		fld		dword [r3+ fsizen(7)]
		fmul	dword [r0+ fsizen(7)]
		fld		dword [r3+ fsizen(8)]
		fmul	dword [r0+ fsizen(8)]
		fxch	st4
		faddp	st5, st0
		fxch	st1
		faddp	st2, st0
		faddp	st2, st0

		fld		dword [r3+ fsizen(9)]
		fmul	dword [r0+ fsizen(9)]
		fld		dword [r3+ fsizen(10)]
		fmul	dword [r0+ fsizen(10)]
		fld		dword [r3+ fsizen(11)]
		fmul	dword [r0+ fsizen(11)]
		fxch	st4
		faddp	st5, st0
		fxch	st1
		faddp	st2, st0
		faddp	st2, st0

		fld		dword [r3+ fsizen(12)]
		fmul	dword [r0+ fsizen(12)]
		fld		dword [r3+ fsizen(13)]
		fmul	dword [r0+ fsizen(13)]
		fld		dword [r3+ fsizen(14)]
		fmul	dword [r0+ fsizen(14)]
		fxch	st4
		faddp	st5, st0
		fxch	st1
		faddp	st2, st0
		faddp	st2, st0

		fld		dword [r3+ fsizen(15)]
		fmul	dword [r0+ fsizen(15)]
		fld		dword [r3+ fsizen(16)]
		fmul	dword [r0+ fsizen(16)]
		fld		dword [r3+ fsizen(17)]
		fmul	dword [r0+ fsizen(17)]
		fxch	st4
		faddp	st5, st0
		fxch	st1
		faddp	st2, st0
		faddp	st2, st0
		add		r1, fsize
		faddp	st2, st0
		add		r3, fsizen(36)
		faddp	st1, st0

		dec		r4
		fstp	dword [r1-fsize]
		jnz near .lp_18

		dec		r2
		jnz near .lp_count

		popd	ebp, edi, esi, ebx
endproc

;***************************************************************

proc	entry_x87_SOA_OoO

		%$coeff			arg		4
		%$in_vector		arg		4
		%$out_vector	arg		4
		%$count			arg		4

		pushd	ebp, edi, esi, ebx
		jmp		.lp_count

		align 16
.lp_count:
		mov		r3, [sp(%$in_vector)]
		mov		r1, [sp(%$coeff)]
		mov		r0, [sp(%$out_vector)]
		mov		r2, r3
		mov		r5, r1
		add		r2, fsizen(64)
		add		r5, fsizen(60)
		mov		r4, 3
		jmp		.lp_3

		align 16
.lp_3:

;0
		fld		dword [r3+ 0*fsizen(4)]		;in
		fld		dword [r1+ 0*fsize]			;c0 in
		fmul	st0, st1
		fld		dword [r1+ 1*fsize]			;c1 c0 in
		fmul	st0, st2
		fld		dword [r1+ 2*fsize]			;c2 c1 c0 in
		fmul	st0, st3
		fld		dword [r1+ 3*fsize]			;c3 c2 c1 c0 in
		fmul	st0, st4
		fld		dword [r1+ 4*fsize]			;c4 c3 c2 c1 c0 in
		fmul	st0, st5
		fld		dword [r1+ 5*fsize]			;c5 c4 c3 c2 c1 c0 in
		fmulp	st6, st0					;c4 c3 c2 c1 c0 c5

%macro muladd6 5
		fld		dword [%1+%2*fsizen(4)+fsizen(32)*(%3)]		;in s4 s3 s2 s1 s0 s5
		fld		dword [%4+ 0*fsize+fsizen(20)*(%5)]			;c0 in
		fmul	st0, st1
		faddp	st6, st0

		fld		dword [%4+ 1*fsize+fsizen(20)*(%5)]			;c1 in
		fmul	st0, st1
		faddp	st5, st0

		fld		dword [%4+ 2*fsize+fsizen(20)*(%5)]			;c2 in
		fmul	st0, st1
		faddp	st4, st0

		fld		dword [%4+ 3*fsize+fsizen(20)*(%5)]			;c3 in
		fmul	st0, st1
		faddp	st3, st0

		fld		dword [%4+ 4*fsize+fsizen(20)*(%5)]			;c4 in
		fmul	st0, st1
		faddp	st2, st0

		fmul	dword [%4+ 5*fsize+fsizen(20)*(%5)]			;c5
		faddp	st6, st0
%endmacro

;1
		muladd6		r3, 1, (0), r1, (1)
		add			r1, fsizen(120)
;2
		muladd6		r3, 2, (0), r5, (-1)
;3
		muladd6		r3, 3, (0), r5, (0)
;4
		muladd6		r3, 4, (0), r5, (1)
		add			r5, fsizen(120)
;5
		muladd6		r3, 5, (0), r1, (-1)
;6
		muladd6		r3, 6, (0), r1, (0)
;7
		muladd6		r3, 7, (0), r1, (1)
		add			r3, fsizen(128)
		add			r1, fsizen(120)
;8
		muladd6		r2, 0, (-1), r5, (-1)
;9
		muladd6		r2, 1, (-1), r5, (0)
;10
		muladd6		r2, 2, (-1), r5, (1)
		add			r5, fsizen(120)
;11
		muladd6		r2, 3, (-1), r1, (-1)
;12
		muladd6		r2, 4, (-1), r1, (0)
;13
		muladd6		r2, 5, (-1), r1, (1)
		add			r1, fsizen(120)
;14
		muladd6		r2, 6, (-1), r5, (-1)
;15
		muladd6		r2, 7, (-1), r5, (0)
;16
		muladd6		r2, 0, (0), r5, (1)
		add			r5, fsizen(120)
;17
		muladd6		r2, 1, (0), r1, (-1)
;18
		muladd6		r2, 2, (0), r1, (0)
;19
		muladd6		r2, 3, (0), r1, (1)
		add			r1, fsizen(120)
;20
		muladd6		r2, 4, (0), r5, (-1)
;21
		muladd6		r2, 5, (0), r5, (0)
;22
		muladd6		r2, 6, (0), r5, (1)
		add			r5, fsizen(120)
;23
		muladd6		r2, 7, (0), r1, (-1)
;24
		muladd6		r3, 0, (-1), r1, (0)
;25
		muladd6		r3, 1, (-1), r1, (1)
		add			r1, fsizen(120)
;26
		muladd6		r3, 2, (-1), r5, (-1)
;27
		muladd6		r3, 3, (-1), r5, (0)
;28
		muladd6		r3, 4, (-1), r5, (1)
		add			r5, fsizen(120)
;29
		muladd6		r3, 5, (-1), r1, (-1)
;30
		muladd6		r3, 6, (-1), r1, (0)
;31
		muladd6		r3, 7, (-1), r1, (1)
		add			r1, fsizen(120)
;32
		muladd6		r3, 0, (0), r5, (-1)
;33
		muladd6		r3, 1, (0), r5, (0)
;34
		muladd6		r3, 2, (0), r5, (1)
;35
		muladd6		r3, 3, (0), r1, (-1)

											;s4 s3 s2 s1 s0 s5
		fxch	st4							;s0 s3 s2 s1 s4 s5
		fstp	dword [r0+fsizen(0)]		;s3 s2 s1 s4 s5
		fxch	st2							;s1 s2 s3 s4 s5
		fstp	dword [r0+fsizen(1)]
		add		r1, fsizen(6)-fsizen(120)*6
		fstp	dword [r0+fsizen(2)]
		add		r5, fsizen(6)-fsizen(120)*5
		fstp	dword [r0+fsizen(3)]
		add		r3, 0-fsizen(128)
		fstp	dword [r0+fsizen(4)]
		fstp	dword [r0+fsizen(5)]

		add		r0, fsizen(6)
		dec		r4
		jnz near .lp_3

		dec		dword [sp(%$count)]
		jnz near .lp_count

		popd	ebp, edi, esi, ebx
endproc

;***************************************************************

