
%include "nasm.h"

[segment_code]

;***************************************************************

proc	entry_SSE_SOA

		%$coeff			arg		4
		%$in_vector		arg		4
		%$out_vector	arg		4
		%$count			arg		4

		pushd	ebp, edi, esi, ebx

		align 32
.lp_count:
		mov			edx, [sp(%$in_vector)]
		mov			ebx, [sp(%$coeff)]
		mov			eax, [sp(%$out_vector)]
		mov			edi, ebx
		add			edi, fsizen(60)

;0
		movaps		xmm6, [edx+0*fsizen(4)]

		movaps		xmm0, [ebx+0*fsize]
		movaps		xmm1, [ebx+4*fsize]
		movaps		xmm2, [ebx+8*fsize]

		mulps		xmm0, xmm6
		movaps		xmm5, [edx+1*fsizen(4)]
		mulps		xmm1, xmm6
		movaps		xmm3, [ebx+0*fsize+fsizen(20)]
		mulps		xmm2, xmm6
;1
		movaps		xmm4, [ebx+4*fsize+fsizen(20)]
		mulps		xmm3, xmm5
		movaps		xmm6, [edx+2*fsizen(4)]
		mulps		xmm4, xmm5
		addps		xmm0, xmm3
		mulps		xmm5, [ebx+8*fsize+fsizen(20)]
		addps		xmm1, xmm4
		movaps		xmm3, [edi+0*fsize-fsizen(20)]
		addps		xmm2, xmm5
;2
		movaps		xmm4, [edi+4*fsize-fsizen(20)]
		mulps		xmm3, xmm6
		movaps		xmm5, [edx+3*fsizen(4)]
		mulps		xmm4, xmm6
		addps		xmm0, xmm3
		mulps		xmm6, [edi+8*fsize-fsizen(20)]
		addps		xmm1, xmm4
		movaps		xmm3, [edi+0*fsize]
		addps		xmm2, xmm6
;3
		movaps		xmm4, [edi+4*fsize]
		mulps		xmm3, xmm5
		movaps		xmm6, [edx+4*fsizen(4)]
		mulps		xmm4, xmm5
		add			ebx, fsizen(120)
		addps		xmm0, xmm3
		mulps		xmm5, [edi+8*fsize]
		addps		xmm1, xmm4
		movaps		xmm3, [edi+0*fsize+fsizen(20)]
		addps		xmm2, xmm5
;4
		movaps		xmm4, [edi+4*fsize+fsizen(20)]
		mulps		xmm3, xmm6
		movaps		xmm5, [edx+5*fsizen(4)]
		mulps		xmm4, xmm6
		addps		xmm0, xmm3
		mulps		xmm6, [edi+8*fsize+fsizen(20)]
		addps		xmm1, xmm4
		movaps		xmm3, [ebx+0*fsize-fsizen(20)]
		addps		xmm2, xmm6
;5
		movaps		xmm4, [ebx+4*fsize-fsizen(20)]
		mulps		xmm3, xmm5
		movaps		xmm6, [edx+6*fsizen(4)]
		mulps		xmm4, xmm5
		add			edi, fsizen(120)
		addps		xmm0, xmm3
		mulps		xmm5, [ebx+8*fsize-fsizen(20)]
		addps		xmm1, xmm4
		movaps		xmm3, [ebx+0*fsize]
		addps		xmm2, xmm5
;6
		movaps		xmm4, [ebx+4*fsize]
		mulps		xmm3, xmm6
		movaps		xmm5, [edx+7*fsizen(4)]
		mulps		xmm4, xmm6
		add			edx, fsizen(64)
		addps		xmm0, xmm3
		mulps		xmm6, [ebx+8*fsize]
		addps		xmm1, xmm4
		movaps		xmm3, [ebx+0*fsize+fsizen(20)]
		addps		xmm2, xmm6
;7
		movaps		xmm4, [ebx+4*fsize+fsizen(20)]
		mulps		xmm3, xmm5
		movaps		xmm6, [edx+0*fsizen(4)-fsizen(32)]
		mulps		xmm4, xmm5
		addps		xmm0, xmm3
		mulps		xmm5, [ebx+8*fsize+fsizen(20)]
		addps		xmm1, xmm4
		movaps		xmm3, [edi+0*fsize-fsizen(20)]
		addps		xmm2, xmm5
;8
		movaps		xmm4, [edi+4*fsize-fsizen(20)]
		mulps		xmm3, xmm6
		movaps		xmm5, [edx+1*fsizen(4)-fsizen(32)]
		mulps		xmm4, xmm6
		addps		xmm0, xmm3
		mulps		xmm6, [edi+8*fsize-fsizen(20)]
		addps		xmm1, xmm4
		movaps		xmm3, [edi+0*fsize]
		addps		xmm2, xmm6
;9
		movaps		xmm4, [edi+4*fsize]
		mulps		xmm3, xmm5
		movaps		xmm6, [edx+2*fsizen(4)-fsizen(32)]
		mulps		xmm4, xmm5
		add			ebx, fsizen(120)
		addps		xmm0, xmm3
		mulps		xmm5, [edi+8*fsize]
		addps		xmm1, xmm4
		movaps		xmm3, [edi+0*fsize+fsizen(20)]
		addps		xmm2, xmm5
;10
		movaps		xmm4, [edi+4*fsize+fsizen(20)]
		mulps		xmm3, xmm6
		movaps		xmm5, [edx+3*fsizen(4)-fsizen(32)]
		mulps		xmm4, xmm6
		addps		xmm0, xmm3
		mulps		xmm6, [edi+8*fsize+fsizen(20)]
		addps		xmm1, xmm4
		movaps		xmm3, [ebx+0*fsize-fsizen(20)]
		addps		xmm2, xmm6
;11
		movaps		xmm4, [ebx+4*fsize-fsizen(20)]
		mulps		xmm3, xmm5
		movaps		xmm6, [edx+4*fsizen(4)-fsizen(32)]
		mulps		xmm4, xmm5
		addps		xmm0, xmm3
		mulps		xmm5, [ebx+8*fsize-fsizen(20)]
		addps		xmm1, xmm4
		movaps		xmm3, [ebx+0*fsize]
		addps		xmm2, xmm5
;12
		movaps		xmm4, [ebx+4*fsize]
		mulps		xmm3, xmm6
		movaps		xmm5, [edx+5*fsizen(4)-fsizen(32)]
		mulps		xmm4, xmm6
		add			edi, fsizen(120)
		addps		xmm0, xmm3
		mulps		xmm6, [ebx+8*fsize]
		addps		xmm1, xmm4
		movaps		xmm3, [ebx+0*fsize+fsizen(20)]
		addps		xmm2, xmm6
;13
		movaps		xmm4, [ebx+4*fsize+fsizen(20)]
		mulps		xmm3, xmm5
		movaps		xmm6, [edx+6*fsizen(4)-fsizen(32)]
		mulps		xmm4, xmm5
		addps		xmm0, xmm3
		mulps		xmm5, [ebx+8*fsize+fsizen(20)]
		addps		xmm1, xmm4
		movaps		xmm3, [edi+0*fsize-fsizen(20)]
		addps		xmm2, xmm5
;14
		movaps		xmm4, [edi+4*fsize-fsizen(20)]
		mulps		xmm3, xmm6
		movaps		xmm5, [edx+7*fsizen(4)-fsizen(32)]
		mulps		xmm4, xmm6
		addps		xmm0, xmm3
		mulps		xmm6, [edi+8*fsize-fsizen(20)]
		addps		xmm1, xmm4
		movaps		xmm3, [edi+0*fsize]
		addps		xmm2, xmm6
;15
		movaps		xmm4, [edi+4*fsize]
		mulps		xmm3, xmm5
		movaps		xmm6, [edx+0*fsizen(4)]
		mulps		xmm4, xmm5
		add			ebx, fsizen(120)
		addps		xmm0, xmm3
		mulps		xmm5, [edi+8*fsize]
		addps		xmm1, xmm4
		movaps		xmm3, [edi+0*fsize+fsizen(20)]
		addps		xmm2, xmm5
;16
		movaps		xmm4, [edi+4*fsize+fsizen(20)]
		mulps		xmm3, xmm6
		movaps		xmm5, [edx+1*fsizen(4)]
		mulps		xmm4, xmm6
		addps		xmm0, xmm3
		mulps		xmm6, [edi+8*fsize+fsizen(20)]
		addps		xmm1, xmm4
		movaps		xmm3, [ebx+0*fsize-fsizen(20)]
		addps		xmm2, xmm6
;17
		movaps		xmm4, [ebx+4*fsize-fsizen(20)]
		mulps		xmm3, xmm5
		movaps		xmm6, [edx+2*fsizen(4)]
		mulps		xmm4, xmm5
		addps		xmm0, xmm3
		mulps		xmm5, [ebx+8*fsize-fsizen(20)]
		addps		xmm1, xmm4
		movaps		xmm3, [ebx+0*fsize]
		addps		xmm2, xmm5
;18
		movaps		xmm4, [ebx+4*fsize]
		mulps		xmm3, xmm6
		movaps		xmm5, [edx+3*fsizen(4)]
		mulps		xmm4, xmm6
		add			edi, fsizen(120)
		addps		xmm0, xmm3
		mulps		xmm6, [ebx+8*fsize]
		addps		xmm1, xmm4
		movaps		xmm3, [ebx+0*fsize+fsizen(20)]
		addps		xmm2, xmm6
;19
		movaps		xmm4, [ebx+4*fsize+fsizen(20)]
		mulps		xmm3, xmm5
		movaps		xmm6, [edx+4*fsizen(4)]
		mulps		xmm4, xmm5
		addps		xmm0, xmm3
		mulps		xmm5, [ebx+8*fsize+fsizen(20)]
		addps		xmm1, xmm4
		movaps		xmm3, [edi+0*fsize-fsizen(20)]
		addps		xmm2, xmm5
;20
		movaps		xmm4, [edi+4*fsize-fsizen(20)]
		mulps		xmm3, xmm6
		movaps		xmm5, [edx+5*fsizen(4)]
		mulps		xmm4, xmm6
		addps		xmm0, xmm3
		mulps		xmm6, [edi+8*fsize-fsizen(20)]
		addps		xmm1, xmm4
		movaps		xmm3, [edi+0*fsize]
		addps		xmm2, xmm6
;21
		movaps		xmm4, [edi+4*fsize]
		mulps		xmm3, xmm5
		movaps		xmm6, [edx+6*fsizen(4)]
		mulps		xmm4, xmm5
		add			ebx, fsizen(120)
		addps		xmm0, xmm3
		mulps		xmm5, [edi+8*fsize]
		addps		xmm1, xmm4
		movaps		xmm3, [edi+0*fsize+fsizen(20)]
		addps		xmm2, xmm5
;22
		movaps		xmm4, [edi+4*fsize+fsizen(20)]
		mulps		xmm3, xmm6
		movaps		xmm5, [edx+7*fsizen(4)]
		mulps		xmm4, xmm6
		add			edx, fsizen(64)
		addps		xmm0, xmm3
		mulps		xmm6, [edi+8*fsize+fsizen(20)]
		addps		xmm1, xmm4
		movaps		xmm3, [ebx+0*fsize-fsizen(20)]
		addps		xmm2, xmm6
;23
		movaps		xmm4, [ebx+4*fsize-fsizen(20)]
		mulps		xmm3, xmm5
		movaps		xmm6, [edx+0*fsizen(4)-fsizen(32)]
		mulps		xmm4, xmm5
		addps		xmm0, xmm3
		mulps		xmm5, [ebx+8*fsize-fsizen(20)]
		addps		xmm1, xmm4
		movaps		xmm3, [ebx+0*fsize]
		addps		xmm2, xmm5
;24
		movaps		xmm4, [ebx+4*fsize]
		mulps		xmm3, xmm6
		movaps		xmm5, [edx+1*fsizen(4)-fsizen(32)]
		mulps		xmm4, xmm6
		add			edi, fsizen(120)
		addps		xmm0, xmm3
		mulps		xmm6, [ebx+8*fsize]
		addps		xmm1, xmm4
		movaps		xmm3, [ebx+0*fsize+fsizen(20)]
		addps		xmm2, xmm6
;25
		movaps		xmm4, [ebx+4*fsize+fsizen(20)]
		mulps		xmm3, xmm5
		movaps		xmm6, [edx+2*fsizen(4)-fsizen(32)]
		mulps		xmm4, xmm5
		addps		xmm0, xmm3
		mulps		xmm5, [ebx+8*fsize+fsizen(20)]
		addps		xmm1, xmm4
		movaps		xmm3, [edi+0*fsize-fsizen(20)]
		addps		xmm2, xmm5
;26
		movaps		xmm4, [edi+4*fsize-fsizen(20)]
		mulps		xmm3, xmm6
		movaps		xmm5, [edx+3*fsizen(4)-fsizen(32)]
		mulps		xmm4, xmm6
		addps		xmm0, xmm3
		mulps		xmm6, [edi+8*fsize-fsizen(20)]
		addps		xmm1, xmm4
		movaps		xmm3, [edi+0*fsize]
		addps		xmm2, xmm6
;27
		movaps		xmm4, [edi+4*fsize]
		mulps		xmm3, xmm5
		movaps		xmm6, [edx+4*fsizen(4)-fsizen(32)]
		mulps		xmm4, xmm5
		add			ebx, fsizen(120)
		addps		xmm0, xmm3
		mulps		xmm5, [edi+8*fsize]
		addps		xmm1, xmm4
		movaps		xmm3, [edi+0*fsize+fsizen(20)]
		addps		xmm2, xmm5
;28
		movaps		xmm4, [edi+4*fsize+fsizen(20)]
		mulps		xmm3, xmm6
		movaps		xmm5, [edx+5*fsizen(4)-fsizen(32)]
		mulps		xmm4, xmm6
		addps		xmm0, xmm3
		mulps		xmm6, [edi+8*fsize+fsizen(20)]
		addps		xmm1, xmm4
		movaps		xmm3, [ebx+0*fsize-fsizen(20)]
		addps		xmm2, xmm6
;29
		movaps		xmm4, [ebx+4*fsize-fsizen(20)]
		mulps		xmm3, xmm5
		movaps		xmm6, [edx+6*fsizen(4)-fsizen(32)]
		mulps		xmm4, xmm5
		addps		xmm0, xmm3
		mulps		xmm5, [ebx+8*fsize-fsizen(20)]
		addps		xmm1, xmm4
		movaps		xmm3, [ebx+0*fsize]
		addps		xmm2, xmm5
;30
		movaps		xmm4, [ebx+4*fsize]
		mulps		xmm3, xmm6
		movaps		xmm5, [edx+7*fsizen(4)-fsizen(32)]
		mulps		xmm4, xmm6
		add			edi, fsizen(120)
		addps		xmm0, xmm3
		mulps		xmm6, [ebx+8*fsize]
		addps		xmm1, xmm4
		movaps		xmm3, [ebx+0*fsize+fsizen(20)]
		addps		xmm2, xmm6
;31
		movaps		xmm4, [ebx+4*fsize+fsizen(20)]
		mulps		xmm3, xmm5
		movaps		xmm6, [edx+0*fsizen(4)]
		mulps		xmm4, xmm5
		addps		xmm0, xmm3
		mulps		xmm5, [ebx+8*fsize+fsizen(20)]
		addps		xmm1, xmm4
		movaps		xmm3, [edi+0*fsize-fsizen(20)]
		addps		xmm2, xmm5
;32
		movaps		xmm4, [edi+4*fsize-fsizen(20)]
		mulps		xmm3, xmm6
		movaps		xmm5, [edx+1*fsizen(4)]
		mulps		xmm4, xmm6
		addps		xmm0, xmm3
		mulps		xmm6, [edi+8*fsize-fsizen(20)]
		addps		xmm1, xmm4
		movaps		xmm3, [edi+0*fsize]
		addps		xmm2, xmm6
;33
		movaps		xmm4, [edi+4*fsize]
		mulps		xmm3, xmm5
		movaps		xmm6, [edx+2*fsizen(4)]
		mulps		xmm4, xmm5
		add			ebx, fsizen(120)
		addps		xmm0, xmm3
		mulps		xmm5, [edi+8*fsize]
		addps		xmm1, xmm4
		movaps		xmm3, [edi+0*fsize+fsizen(20)]
		addps		xmm2, xmm5
;34
		movaps		xmm4, [edi+4*fsize+fsizen(20)]
		mulps		xmm3, xmm6
		movaps		xmm5, [edx+3*fsizen(4)]
		mulps		xmm4, xmm6
		addps		xmm0, xmm3
		mulps		xmm6, [edi+8*fsize+fsizen(20)]
		addps		xmm1, xmm4
		movaps		xmm3, [ebx+0*fsize-fsizen(20)]
		addps		xmm2, xmm6
;35
		movaps		xmm4, [ebx+4*fsize-fsizen(20)]
		mulps		xmm3, xmm5
		mulps		xmm4, xmm5
		addps		xmm0, xmm3
		mulps		xmm5, [ebx+8*fsize-fsizen(20)]
		sub			edx, 2*fsizen(64)
		addps		xmm1, xmm4
		sub			edi, 5*fsizen(120)-12*fsize
		movaps		[eax+0*fsize], xmm0
		sub			ebx, 6*fsizen(120)-12*fsize
		addps		xmm2, xmm5
		movaps		[eax+4*fsize], xmm1
		movaps		[eax+8*fsize], xmm2

;0
		movaps		xmm6, [edx+0*fsizen(4)]

		movaps		xmm0, [ebx+0*fsize]
		movaps		xmm2, [ebx+4*fsize]

		movaps		xmm5, [edx+1*fsizen(4)]
		mulps		xmm0, xmm6
		movaps		xmm3, [ebx+0*fsize+fsizen(20)]
		mulps		xmm2, xmm6
;1
		mulps		xmm3, xmm5
		movaps		xmm6, [edx+2*fsizen(4)]
		addps		xmm0, xmm3
		mulps		xmm5, [ebx+4*fsize+fsizen(20)]
		movaps		xmm3, [edi+0*fsize-fsizen(20)]
		addps		xmm2, xmm5
;2
		mulps		xmm3, xmm6
		movaps		xmm5, [edx+3*fsizen(4)]
		addps		xmm0, xmm3
		mulps		xmm6, [edi+4*fsize-fsizen(20)]
		movaps		xmm3, [edi+0*fsize]
		addps		xmm2, xmm6
;3
		mulps		xmm3, xmm5
		movaps		xmm6, [edx+4*fsizen(4)]
		add			ebx, fsizen(120)
		addps		xmm0, xmm3
		mulps		xmm5, [edi+4*fsize]
		movaps		xmm3, [edi+0*fsize+fsizen(20)]
		addps		xmm2, xmm5
;4
		mulps		xmm3, xmm6
		movaps		xmm5, [edx+5*fsizen(4)]
		addps		xmm0, xmm3
		mulps		xmm6, [edi+4*fsize+fsizen(20)]
		movaps		xmm3, [ebx+0*fsize-fsizen(20)]
		addps		xmm2, xmm6
;5
		mulps		xmm3, xmm5
		movaps		xmm6, [edx+6*fsizen(4)]
		add			edi, fsizen(120)
		addps		xmm0, xmm3
		mulps		xmm5, [ebx+4*fsize-fsizen(20)]
		movaps		xmm3, [ebx+0*fsize]
		addps		xmm2, xmm5
;6
		mulps		xmm3, xmm6
		movaps		xmm5, [edx+7*fsizen(4)]
		add			edx, fsizen(64)
		addps		xmm0, xmm3
		mulps		xmm6, [ebx+4*fsize]
		movaps		xmm3, [ebx+0*fsize+fsizen(20)]
		addps		xmm2, xmm6
;7
		mulps		xmm3, xmm5
		movaps		xmm6, [edx+0*fsizen(4)-fsizen(32)]
		addps		xmm0, xmm3
		mulps		xmm5, [ebx+4*fsize+fsizen(20)]
		movaps		xmm3, [edi+0*fsize-fsizen(20)]
		addps		xmm2, xmm5
;8
		mulps		xmm3, xmm6
		movaps		xmm5, [edx+1*fsizen(4)-fsizen(32)]
		addps		xmm0, xmm3
		mulps		xmm6, [edi+4*fsize-fsizen(20)]
		movaps		xmm3, [edi+0*fsize]
		addps		xmm2, xmm6
;9
		mulps		xmm3, xmm5
		movaps		xmm6, [edx+2*fsizen(4)-fsizen(32)]
		add			ebx, fsizen(120)
		addps		xmm0, xmm3
		mulps		xmm5, [edi+4*fsize]
		movaps		xmm3, [edi+0*fsize+fsizen(20)]
		addps		xmm2, xmm5
;10
		mulps		xmm3, xmm6
		movaps		xmm5, [edx+3*fsizen(4)-fsizen(32)]
		addps		xmm0, xmm3
		mulps		xmm6, [edi+4*fsize+fsizen(20)]
		movaps		xmm3, [ebx+0*fsize-fsizen(20)]
		addps		xmm2, xmm6
;11
		mulps		xmm3, xmm5
		movaps		xmm6, [edx+4*fsizen(4)-fsizen(32)]
		addps		xmm0, xmm3
		mulps		xmm5, [ebx+4*fsize-fsizen(20)]
		movaps		xmm3, [ebx+0*fsize]
		addps		xmm2, xmm5
;12
		mulps		xmm3, xmm6
		movaps		xmm5, [edx+5*fsizen(4)-fsizen(32)]
		add			edi, fsizen(120)
		addps		xmm0, xmm3
		mulps		xmm6, [ebx+4*fsize]
		movaps		xmm3, [ebx+0*fsize+fsizen(20)]
		addps		xmm2, xmm6
;13
		mulps		xmm3, xmm5
		movaps		xmm6, [edx+6*fsizen(4)-fsizen(32)]
		addps		xmm0, xmm3
		mulps		xmm5, [ebx+4*fsize+fsizen(20)]
		movaps		xmm3, [edi+0*fsize-fsizen(20)]
		addps		xmm2, xmm5
;14
		mulps		xmm3, xmm6
		movaps		xmm5, [edx+7*fsizen(4)-fsizen(32)]
		addps		xmm0, xmm3
		mulps		xmm6, [edi+4*fsize-fsizen(20)]
		movaps		xmm3, [edi+0*fsize]
		addps		xmm2, xmm6
;15
		mulps		xmm3, xmm5
		movaps		xmm6, [edx+0*fsizen(4)]
		add			ebx, fsizen(120)
		addps		xmm0, xmm3
		mulps		xmm5, [edi+4*fsize]
		movaps		xmm3, [edi+0*fsize+fsizen(20)]
		addps		xmm2, xmm5
;16
		mulps		xmm3, xmm6
		movaps		xmm5, [edx+1*fsizen(4)]
		addps		xmm0, xmm3
		mulps		xmm6, [edi+4*fsize+fsizen(20)]
		movaps		xmm3, [ebx+0*fsize-fsizen(20)]
		addps		xmm2, xmm6
;17
		mulps		xmm3, xmm5
		movaps		xmm6, [edx+2*fsizen(4)]
		addps		xmm0, xmm3
		mulps		xmm5, [ebx+4*fsize-fsizen(20)]
		movaps		xmm3, [ebx+0*fsize]
		addps		xmm2, xmm5
;18
		mulps		xmm3, xmm6
		movaps		xmm5, [edx+3*fsizen(4)]
		add			edi, fsizen(120)
		addps		xmm0, xmm3
		mulps		xmm6, [ebx+4*fsize]
		movaps		xmm3, [ebx+0*fsize+fsizen(20)]
		addps		xmm2, xmm6
;19
		mulps		xmm3, xmm5
		movaps		xmm6, [edx+4*fsizen(4)]
		addps		xmm0, xmm3
		mulps		xmm5, [ebx+4*fsize+fsizen(20)]
		movaps		xmm3, [edi+0*fsize-fsizen(20)]
		addps		xmm2, xmm5
;20
		mulps		xmm3, xmm6
		movaps		xmm5, [edx+5*fsizen(4)]
		addps		xmm0, xmm3
		mulps		xmm6, [edi+4*fsize-fsizen(20)]
		movaps		xmm3, [edi+0*fsize]
		addps		xmm2, xmm6
;21
		mulps		xmm3, xmm5
		movaps		xmm6, [edx+6*fsizen(4)]
		add			ebx, fsizen(120)
		addps		xmm0, xmm3
		mulps		xmm5, [edi+4*fsize]
		movaps		xmm3, [edi+0*fsize+fsizen(20)]
		addps		xmm2, xmm5
;22
		mulps		xmm3, xmm6
		movaps		xmm5, [edx+7*fsizen(4)]
		add			edx, fsizen(64)
		addps		xmm0, xmm3
		mulps		xmm6, [edi+4*fsize+fsizen(20)]
		movaps		xmm3, [ebx+0*fsize-fsizen(20)]
		addps		xmm2, xmm6
;23
		mulps		xmm3, xmm5
		movaps		xmm6, [edx+0*fsizen(4)-fsizen(32)]
		addps		xmm0, xmm3
		mulps		xmm5, [ebx+4*fsize-fsizen(20)]
		movaps		xmm3, [ebx+0*fsize]
		addps		xmm2, xmm5
;24
		mulps		xmm3, xmm6
		movaps		xmm5, [edx+1*fsizen(4)-fsizen(32)]
		add			edi, fsizen(120)
		addps		xmm0, xmm3
		mulps		xmm6, [ebx+4*fsize]
		movaps		xmm3, [ebx+0*fsize+fsizen(20)]
		addps		xmm2, xmm6
;25
		mulps		xmm3, xmm5
		movaps		xmm6, [edx+2*fsizen(4)-fsizen(32)]
		addps		xmm0, xmm3
		mulps		xmm5, [ebx+4*fsize+fsizen(20)]
		movaps		xmm3, [edi+0*fsize-fsizen(20)]
		addps		xmm2, xmm5
;26
		mulps		xmm3, xmm6
		movaps		xmm5, [edx+3*fsizen(4)-fsizen(32)]
		addps		xmm0, xmm3
		mulps		xmm6, [edi+4*fsize-fsizen(20)]
		movaps		xmm3, [edi+0*fsize]
		addps		xmm2, xmm6
;27
		mulps		xmm3, xmm5
		movaps		xmm6, [edx+4*fsizen(4)-fsizen(32)]
		add			ebx, fsizen(120)
		addps		xmm0, xmm3
		mulps		xmm5, [edi+4*fsize]
		movaps		xmm3, [edi+0*fsize+fsizen(20)]
		addps		xmm2, xmm5
;28
		mulps		xmm3, xmm6
		movaps		xmm5, [edx+5*fsizen(4)-fsizen(32)]
		addps		xmm0, xmm3
		mulps		xmm6, [edi+4*fsize+fsizen(20)]
		movaps		xmm3, [ebx+0*fsize-fsizen(20)]
		addps		xmm2, xmm6
;29
		mulps		xmm3, xmm5
		movaps		xmm6, [edx+6*fsizen(4)-fsizen(32)]
		addps		xmm0, xmm3
		mulps		xmm5, [ebx+4*fsize-fsizen(20)]
		movaps		xmm3, [ebx+0*fsize]
		addps		xmm2, xmm5
;30
		mulps		xmm3, xmm6
		movaps		xmm5, [edx+7*fsizen(4)-fsizen(32)]
		add			edi, fsizen(120)
		addps		xmm0, xmm3
		mulps		xmm6, [ebx+4*fsize]
		movaps		xmm3, [ebx+0*fsize+fsizen(20)]
		addps		xmm2, xmm6
;31
		mulps		xmm3, xmm5
		movaps		xmm6, [edx+0*fsizen(4)]
		addps		xmm0, xmm3
		mulps		xmm5, [ebx+4*fsize+fsizen(20)]
		movaps		xmm3, [edi+0*fsize-fsizen(20)]
		addps		xmm2, xmm5
;32
		mulps		xmm3, xmm6
		movaps		xmm5, [edx+1*fsizen(4)]
		addps		xmm0, xmm3
		mulps		xmm6, [edi+4*fsize-fsizen(20)]
		movaps		xmm3, [edi+0*fsize]
		addps		xmm2, xmm6
;33
		mulps		xmm3, xmm5
		movaps		xmm6, [edx+2*fsizen(4)]
		add			ebx, fsizen(120)
		addps		xmm0, xmm3
		mulps		xmm5, [edi+4*fsize]
		movaps		xmm3, [edi+0*fsize+fsizen(20)]
		addps		xmm2, xmm5
;34
		mulps		xmm3, xmm6
		movaps		xmm5, [edx+3*fsizen(4)]
		addps		xmm0, xmm3
		mulps		xmm6, [edi+4*fsize+fsizen(20)]
		movaps		xmm3, [ebx+0*fsize-fsizen(20)]
		addps		xmm2, xmm6
;35
		mulps		xmm3, xmm5
		addps		xmm0, xmm3
		mulps		xmm5, [ebx+4*fsize-fsizen(20)]
		movaps		[eax+12*fsize], xmm0
		addps		xmm2, xmm5
		movaps		[eax+16*fsize], xmm2

		dec			dword [sp(%$count)]
		jnz	near	.lp_count

		popd	ebp, edi, esi, ebx
endproc

;***************************************************************

proc	entry_SSE_SOA_OoO

		%$coeff			arg		4
		%$in_vector		arg		4
		%$out_vector	arg		4
		%$count			arg		4

		pushd	ebp, edi, esi, ebx

		align 32
.lp_count:
		mov			r3, [sp(%$in_vector)]
		mov			r1, [sp(%$coeff)]
		mov			r0, [sp(%$out_vector)]
		mov			r2, r3
		mov			r5, r1
		add			r2, fsizen(64)
		add			r5, fsizen(60)

%macro muladd3 5
		movaps		xmm5, [%1+%2*fsizen(4)+fsizen(32)*(%3)]
		movaps		xmm6, [%4+ 0*fsize+fsizen(20)*(%5)]

		mulps		xmm6, xmm5
		movaps		xmm7, [%4+ 4*fsize+fsizen(20)*(%5)]
		addps		xmm0, xmm6

		mulps		xmm7, xmm5
		movaps		xmm6, [%4+ 8*fsize+fsizen(20)*(%5)]
		addps		xmm1, xmm7
		
		mulps		xmm6, xmm5
		movaps		xmm7, [%4+12*fsize+fsizen(20)*(%5)]
		addps		xmm2, xmm6

		mulps		xmm7, xmm5
		addps		xmm3, xmm7

		mulps		xmm5, [%4+16*fsize+fsizen(20)*(%5)]
		addps		xmm4, xmm5
%endmacro

;0
		movaps		xmm4, [r3+0*fsizen(4)]

		movaps		xmm0, [r1+ 0*fsize]
		mulps		xmm0, xmm4

		movaps		xmm1, [r1+ 4*fsize]
		mulps		xmm1, xmm4

		movaps		xmm2, [r1+ 8*fsize]
		mulps		xmm2, xmm4

		movaps		xmm3, [r1+12*fsize]
		mulps		xmm3, xmm4

		mulps		xmm4, [r1+16*fsize]

;1
		muladd3		r3, 1, (0), r1, (1)
		add			r1, fsizen(120)
;2
		muladd3		r3, 2, (0), r5, (-1)
;3
		muladd3		r3, 3, (0), r5, (0)
;4
		muladd3		r3, 4, (0), r5, (1)
		add			r5, fsizen(120)
;5
		muladd3		r3, 5, (0), r1, (-1)
;6
		muladd3		r3, 6, (0), r1, (0)
;7
		muladd3		r3, 7, (0), r1, (1)
		add			r3, fsizen(128)
		add			r1, fsizen(120)
;8
		muladd3		r2, 0, (-1), r5, (-1)
;9
		muladd3		r2, 1, (-1), r5, (0)
;10
		muladd3		r2, 2, (-1), r5, (1)
		add			r5, fsizen(120)
;11
		muladd3		r2, 3, (-1), r1, (-1)
;12
		muladd3		r2, 4, (-1), r1, (0)
;13
		muladd3		r2, 5, (-1), r1, (1)
		add			r1, fsizen(120)
;14
		muladd3		r2, 6, (-1), r5, (-1)
;15
		muladd3		r2, 7, (-1), r5, (0)
;16
		muladd3		r2, 0, (0), r5, (1)
		add			r5, fsizen(120)
;17
		muladd3		r2, 1, (0), r1, (-1)
;18
		muladd3		r2, 2, (0), r1, (0)
;19
		muladd3		r2, 3, (0), r1, (1)
		add			r1, fsizen(120)
;20
		muladd3		r2, 4, (0), r5, (-1)
;21
		muladd3		r2, 5, (0), r5, (0)
;22
		muladd3		r2, 6, (0), r5, (1)
		add			r5, fsizen(120)
;23
		muladd3		r2, 7, (0), r1, (-1)
;24
		muladd3		r3, 0, (-1), r1, (0)
;25
		muladd3		r3, 1, (-1), r1, (1)
		add			r1, fsizen(120)
;26
		muladd3		r3, 2, (-1), r5, (-1)
;27
		muladd3		r3, 3, (-1), r5, (0)
;28
		muladd3		r3, 4, (-1), r5, (1)
		add			r5, fsizen(120)
;29
		muladd3		r3, 5, (-1), r1, (-1)
;30
		muladd3		r3, 6, (-1), r1, (0)
;31
		muladd3		r3, 7, (-1), r1, (1)
		add			r1, fsizen(120)
;32
		muladd3		r3, 0, (0), r5, (-1)
;33
		muladd3		r3, 1, (0), r5, (0)
;34
		muladd3		r3, 2, (0), r5, (1)
;35
		muladd3		r3, 3, (0), r1, (-1)
		movaps		[r0+ 0*fsize], xmm0
		movaps		[r0+ 4*fsize], xmm1
		movaps		[r0+ 8*fsize], xmm2
		movaps		[r0+12*fsize], xmm3
		movaps		[r0+16*fsize], xmm4

		dec			dword [sp(%$count)]
		jnz	near	.lp_count

		popd	ebp, edi, esi, ebx
endproc

;***************************************************************

